/*
 * Copyright (C) 2000-2004 by ETH Zurich
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY ETH ZURICH AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ETH ZURICH
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.btnode.ethz.ch
 *
 */


#include <string.h>
#include <terminal/btn-terminal.h>
#include <sys/osdebug.h>
#include <sys/heap.h>

void _nut_cmds_system_cmd_print_usage(void)
{
    DEBUGT("nut: error: usage:\n"
           " nut threads\n"
           " nut timers\n"
           " nut heap\n");
}

void _nut_cmds_system_cmd(char * arg)
{
    if (!strncmp(arg, "threads", 7)) {
        NutDumpThreadList(debug_uart);
    } else if (!strncmp(arg, "timers", 6)) {
        NutDumpTimerList(debug_uart);
    } else if (!strncmp(arg, "heap", 4)) {
        DEBUGT("Nut: Heap Available = %u bytes.\n", NutHeapAvailable());
    } else {
        _nut_cmds_system_cmd_print_usage();
    }
}

void nut_cmds_register_cmds(void)
{
    btn_terminal_register_cmd("nut", _nut_cmds_system_cmd);
}
