#include <string.h>
#include <terminal/btn-terminal.h>
#include <sync/sync.h>

void _sync_cmds_print_usage(void)
{
	DEBUGT("sync: error: usage: mode [get | set] <val>\n");
}

void _sync_cmd_print_mode(void)
{
	DEBUGT("mode is set to ");
	if (sync_globals.is_anchor)
		DEBUGT("anchor node.\n");
	else
		DEBUGT("sensor node.\n");
}

void _sync_cmd_mode(char* arg)
{
    int val;
    
    if (!strncmp(arg, "get", 3)) {
    	_sync_cmd_print_mode();
    }
    else if (!strncmp(arg, "set", 3)) {
    	arg += 3;
	    if (sscanf(arg, "%u", &val) == 1) {
	    	sync_globals.is_anchor = val;
	    	// (re-)initialize rt
	    	rt_init();
			// print current mode
			_sync_cmd_print_mode();
	    }
	    else
	    	_sync_cmds_print_usage();
    }
    else _sync_cmds_print_usage();
}

void _sync_cmd_sync_cmds(char* arg) {
    if (!strncmp(arg, "mode", 4)) {
    	_sync_cmd_mode(arg+5);
    } else {
    	_sync_cmds_print_usage();
    }
}

void sync_cmds_register_cmds(void)
{
    btn_terminal_register_cmd("sync", _sync_cmd_sync_cmds);
}

